Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 452972 - Internal compiler error with G++. OpenMP and GSL RNG
Summary: Internal compiler error with G++. OpenMP and GSL RNG
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: gcc
Version: 5.2
Hardware: i686
OS: Linux
low
medium
Target Milestone: rc
: ---
Assignee: Jakub Jelinek
QA Contact:
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2008-06-26 11:29 UTC by torquil
Modified: 2009-01-20 21:25 UTC (History)
1 user (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2009-01-20 21:25:08 UTC


Attachments (Terms of Use)
Preprocessed test case (deleted)
2008-06-26 11:57 UTC, torquil
no flags Details


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHBA-2009:0157 normal SHIPPED_LIVE gcc bug-fix update 2009-01-20 16:05:12 UTC
GNU Compiler Collection 36237 None None None Never

Description torquil 2008-06-26 11:29:02 UTC
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (compatible; Konqueror/3.5; Linux) KHTML/3.5.4 (like Gecko)

Description of problem:
I have a simple C++ test program using OpenMP, GSL and Blitz that gives an 
internal compiler error. The error message said that I should report it here.

I have installed a self-compiled GSL in my home folder. Maybe you guys can 
test with a standard GSL/Blitz++ if that comes precompiled with RHEL5.2.

Here is the simple test program openmp_gsl_rng.cpp:

#include <blitz/array.h>
#include <gsl/gsl_rng.h>

using namespace std; using namespace blitz;

Array<double,1> R(2);

int main()
{
#pragma omp parallel private(R)
	{
		const gsl_rng* r = gsl_rng_alloc(gsl_rng_mt19937);

	}
	return 0;
}



Version-Release number of selected component (if applicable):
4.1.2-42.el5

How reproducible:
Always


Steps to Reproduce:
1. I try to compile with:
$ g++  
openmp_gsl_rng.cpp -I/mn/anatu/cma-u3/tmac/usr/include -L/mn/anatu/cma-u3/tmac/usr/lib -lgsl -lgslcblas -fopenmp


Actual Results:
I get the following error message:

openmp_gsl_rng.cpp: In function 'int main()':
openmp_gsl_rng.cpp:0: internal compiler error: in lower_stmt, at 
gimple-low.c:231

Expected Results:


Additional info:
If I don't try to make the variable R private, then it compiles without 
errors.

Software versions:
GSL v1.9
Blitz++ v0.9

Comment 1 Jakub Jelinek 2008-06-26 11:50:52 UTC
Please attach preprocessed testcase.  I.e. run
g++ -E openmp_gsl_rng.cpp -I/mn/anatu/cma-u3/tmac/usr/include
-L/mn/anatu/cma-u3/tmac/usr/lib -fopenmp -o openmp_gsl_rng.ii
and attach the *.ii file.  Thanks.

Comment 2 torquil 2008-06-26 11:57:50 UTC
Created attachment 310323 [details]
Preprocessed test case

This is the output that was automatically produced by g++, and stored by it in
the file /tmp/ccWuAWvr.out.

Comment 3 Jakub Jelinek 2008-06-27 16:23:36 UTC
This is upstream PR36237, fixed last month.

Comment 4 RHEL Product and Program Management 2008-06-27 16:32:48 UTC
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux maintenance release.  Product Management has requested
further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed
products.  This request is not yet committed for inclusion in an Update
release.

Comment 11 errata-xmlrpc 2009-01-20 21:25:08 UTC
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHBA-2009-0157.html


Note You need to log in before you can comment on or make changes to this bug.